diff -NurpP --minimal linux-2.4.24-vs1.24/Makefile linux-2.4.24-vs1.25/Makefile
--- linux-2.4.24-vs1.24/Makefile	2004-01-17 05:27:22.000000000 +0100
+++ linux-2.4.24-vs1.25/Makefile	2004-02-06 00:18:03.000000000 +0100
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 4
 SUBLEVEL = 24
-EXTRAVERSION = -vs1.24
+EXTRAVERSION = -vs1.25
 
 KERNELRELEASE=$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
 
diff -NurpP --minimal linux-2.4.24-vs1.24/fs/open.c linux-2.4.24-vs1.25/fs/open.c
--- linux-2.4.24-vs1.24/fs/open.c	2004-01-17 05:27:22.000000000 +0100
+++ linux-2.4.24-vs1.25/fs/open.c	2004-02-06 00:18:04.000000000 +0100
@@ -476,6 +476,10 @@ asmlinkage long sys_fchmod(unsigned int 
 	dentry = file->f_dentry;
 	inode = dentry->d_inode;
 
+	err = -EPERM;
+        if ((inode->i_mode & 0777) == 0 && S_ISDIR(inode->i_mode)
+                && !vx_check(0, VX_ADMIN))
+		goto out_putf;	
 	err = -EROFS;
 	if (IS_RDONLY(inode))
 		goto out_putf;
@@ -506,6 +510,11 @@ asmlinkage long sys_chmod(const char * f
 		goto out;
 	inode = nd.dentry->d_inode;
 
+	error = -EPERM;
+        if ((inode->i_mode & 0777) == 0 && S_ISDIR(inode->i_mode)
+                && !vx_check(0, VX_ADMIN))
+		goto dput_and_out;	
+
 	error = -EROFS;
 	if (IS_RDONLY(inode))
 		goto dput_and_out;
